require 'yaml'
require 'easy_type/puppet_service'
require 'easy_type/node_group'

module EasyType
class Classifier < PuppetService
  def initialize
    super
    port       = 4433
    prefix     = '/classifier-api' 
    @base_url = "https://#{@server}:#{port}#{prefix}"
  end

  def find_by_name(name)
    node_groups.find {|g| g.name == name }
  end

  def find_by_id(id)
    node_groups.find {|g| g.id == id }
  end

  def node_groups
    return @node_groups if @node_groups
    @node_groups = get('/v1/groups').collect {|g| NodeGroup.new(self, g) }
  end

  def em_groups
    node_groups.select {|g| g.em_group? }
  end

  def rule_to_pdb_query(rules)
    post('/v1/rules/translate', rules)
  end

end
end