require 'easy_type/pdb'

module EasyType
# Simple wrapper arround a node group
class NodeGroup

  attr_reader :parent_name


  def initialize(classifier, data)
    @@pdb ||= EasyType::Pdb.new
    @@all_groups ||= [] 
    @data = data
    @classifier = classifier
    @@all_groups << self
  end

  #
  # The top level group containin all licensed nodes
  def em_group
    'EM licensed nodes'
  end

  def method_missing(method)
    str = method.id2name
    raise NoMethodError.new("undefined method `#{method}' for #{name}:EasyType::NodeGroup") if @data[str].nil?
    @data[str]
  end

  def full_name
    value = [name]
    current_group = self
    while true do
      parent_group = @@all_groups.find {|g| g.id == current_group.parent }
      break if current_group.id == parent_group.id
      value << parent_group.name
      current_group = parent_group
    end
    "/#{value.reverse.join('/')}"
  end

  def em_group?
    full_name.include?(em_group)
  end

  def matching_nodes
    if @data['rule']
      pdb_query = @classifier.rule_to_pdb_query(@data['rule'])
      @@pdb.nodes(pdb_query['query'])
    else
      []
    end
  end
end
end