#
# See the file "LICENSE" for the full license governing this code.
#
# frozen_string_literal: true

require 'entitlement/entry'

module Entitlement
  # Docs
  class OpenSourceEntry < Entry
    def initialize(modules, from = nil, to = nil, filename_string = nil, &proc)
      super(modules, from, to, &proc)
    end

    def valid?(module_name, resources = nil)
      Puppet.debug 'Found an Open Source entitlement....'
      super
    end

    def inspect
      super
      puts 'Entitlement : OpenSource edition. Check http://enterprisemodules.com/ for supported editions.'
    end
  end
end
