#
# See the file "LICENSE" for the full license governing this code.
#
# frozen_string_literal: true

require 'easy_type'
require 'easy_type/in_control'

Puppet::Type.type(:validation_results).provide(:direct) do
  include EasyType::Provider

  desc 'Report validation results directly to in-control server'

  defaultfor :in_control_running => true

  mk_resource_methods

  def insync?(_)
    results = {}
    results[:certname] = resource.catalog.name
    results[:envname] = resource.catalog.environment
    results[:results] = resource.results
    results[:report_receive_time] = Time.now
    results[:report_id] = resource.catalog.catalog_uuid
    in_control = EasyType::InControl.new
    in_control.results(results)
    true
  end
end
