#
# See the file "LICENSE" for the full license governing this code.
#
# frozen_string_literal: true

newparam(:input_array_separator) do
  include EasyType

  desc <<-DESC
    The separator of a string to divide it into an array, when reading the data.

    The `add_value` and `remove_value` only work on arrays. But what if it is not a Puppet regular array, but
    a string with a spearator. In that case specify the sperator here.

  DESC

  data_type("Variant[Enum['none'], String[1,1]]")
  defaultto 'none'
end
