#
# See the file "LICENSE" for the full license governing this code.
#
#++--++
#--++--
define easy_type::secure::ensure_set (
  String[1]                 $set,
  Easy_type::Baseline_type  $benchmark,
  Optional[String[1]]       $product_version,
  Optional[String[1]]       $doc_version,
  Optional[String[1]]       $use_schedule,
  Easy_type::Operation      $operation = 'enforce',
  Easy_type::Report_as      $report_as = 'warning',
) {
  $use_schedule_string = if $use_schedule == undef {
    undef
  } else {
    $use_schedule
  }
  #
  # because sometimes we get unexplained "class already defined" messages, we allow users to
  # override the class generation feature. By default we DO generate the class names. When the hiera variable
  # `easy_type::generate_reference_classes` is set to `false` we skip this.
  #
  $generate_reference_classes = lookup('easy_type::generate_reference_classes', Boolean, undef, true )

  $control_set = lookup("${caller_module_name}::sets::${set}", Array[String[1]], undef, undef)

  if $product_version and $doc_version {
    easy_type::validate_versions($caller_module_name, $benchmark, $product_version, $doc_version)
    $control_map = lookup("${caller_module_name}::control_map", Hash[String[1], String[1]], undef, undef)
    $sanitized_doc_version = regsubst($doc_version,/\./,'_','G').downcase

    if $operation in ['enforce', 'both'] {
      echo { "Apply ${caller_module_name} control set ${set} from ${product_version} ${doc_version} on ${title}.":
        withpath => false,
      }
    }

    $selected_controls = $control_map.filter |$chapter, $control| {
      $control in $control_set
    }

    #
    # Now call back to the original module and see if we need to filter out some of the controls
    #
    $current_controls = call("${caller_module_name}::filter_controls", $title, $selected_controls)

    $current_controls.each |String[1] $paragraph_name, String[1] $control_name | {
      easy_type::secure::ensure_control { "${control_name}@${title}":
        caller            => $caller_module_name,
        product_version   => $product_version,
        doc_version       => $doc_version,
        use_schedule      => $use_schedule_string,
        default_operation => $operation,
        report_as         => $report_as,
      }
    }
  }
}
